<?php
/**
 * Plugin Name: Doliconnect
 * Plugin URI: https://www.ptibogxiv.net
 * Description: Connect your Dolibarr (free ERP/CRM) to Wordpress. 
 * Version: 3.12.1
 * Author: ptibogxiv
 * Author URI: https://www.ptibogxiv.net/en
 * Network: true
 * License: GPLv3 or later
 * License URI: http://www.gnu.org/licenses/gpl-3.0.txt
 * Text Domain: doliconnect
 * Domain Path: /languages
 * Donate link: https://www.paypal.me/ptibogxiv
 *   
 * @author ptibogxiv.net <support@ptibogxiv.net>
 * @copyright Copyright (c) 2017-2019, ptibogxiv.net
**/

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}  
 
function doliconnect_textdomain() {
    load_plugin_textdomain( 'doliconnect', false, basename( dirname( __FILE__ ) ) . '/languages/' );
}
add_action( 'plugins_loaded', 'doliconnect_textdomain' );

require_once plugin_dir_path(__FILE__).'/functions/enqueues.php';
require_once plugin_dir_path(__FILE__).'/functions/data-request.php';
require_once plugin_dir_path(__FILE__).'/functions/tools.php';
require_once plugin_dir_path(__FILE__).'/functions/widgets.php';
require_once plugin_dir_path(__FILE__).'/dashboard/templates.php';
require_once plugin_dir_path(__FILE__).'/dashboard/dashboard.php';
require_once plugin_dir_path(__FILE__).'/functions/product.php';
require_once plugin_dir_path(__FILE__).'/admin/admin.php'; 
require_once plugin_dir_path(__FILE__).'/blocks/index.php';
//include_once( ABSPATH . 'wp-admin/includes/plugin.php' );

// ********************************************************
function doliconnecturl($page) {
global $wpdb;
if ( function_exists('pll_get_post') ) { 
return esc_url(get_permalink(pll_get_post(get_option($page))));
} elseif ( function_exists('wpml_object_id') ) {
return esc_url(get_permalink(apply_filters( 'wpml_object_id', get_option($page), 'page', true)));
} else {
return esc_url(get_permalink(get_option($page)));
}  
}

function doliconnectid($page) {
global $wpdb;
if (function_exists('pll_get_post')) { 
return pll_get_post(get_option($page));
} elseif ( function_exists('wpml_object_id') ) {
return apply_filters( 'wpml_object_id', get_option($page), 'page', true);
} else {
return get_option($page);
}  
}
// ********************************************************
function app_output_buffer() {
ob_start();
} 
add_action('init', 'app_output_buffer');
// ********************************************************
function dolibarr_entity( $entity = null ) {

if ( !empty($entity) ) {
return $entity;
} elseif ( get_site_option('dolibarr_entity') && get_option('dolibarr_entity') ) {
return get_option('dolibarr_entity');
} else {
return get_current_blog_id();
}
//return get_current_network_id();
}
add_action( 'admin_init', 'dolibarr_entity', 5); 
// ********************************************************
function doliconst( $constante ) {
global $wpdb;

$const = callDoliApi("GET", "/doliconnector/constante/".$constante, null, dolidelay('constante'));

return $const->value;
}
// ********************************************************
function doliconnect_run() {
$array=array();
if ( !empty(doliconnectid('doliaccount')) ) { $array[]=doliconnectid('doliaccount'); }
if ( !empty(doliconnectid('dolicart')) ) { $array[]=doliconnectid('dolicart'); }
if ( !empty($array) && is_page( $array ) ) {
if ( !defined ('DONOTCACHEPAGE') ) {
define( 'DONOTCACHEPAGE', 1);
}
}
}
add_action( 'wp_head', 'doliconnect_run', 10, 0 );
// ********************************************************
function json_basic_auth_handler( $user ) {
	global $wp_json_basic_auth_error;
	$wp_json_basic_auth_error = null;

	if ( ! empty( $user ) ) {
		return $user;
	}

	if ( !isset( $_SERVER['PHP_AUTH_USER'] ) ) {
		return $user;
	}
	$username = $_SERVER['PHP_AUTH_USER'];
	$password = $_SERVER['PHP_AUTH_PW'];

	remove_filter( 'determine_current_user', 'json_basic_auth_handler', 20 );
	$user = wp_authenticate( $username, $password );
	add_filter( 'determine_current_user', 'json_basic_auth_handler', 20 );
	if ( is_wp_error( $user ) ) {
		$wp_json_basic_auth_error = $user;
		return null;
	}
	$wp_json_basic_auth_error = true;
	return $user->ID;
}
add_filter( 'determine_current_user', 'json_basic_auth_handler', 20 );
function json_basic_auth_error( $error ) {
	// Passthrough other errors
	if ( ! empty( $error ) ) {
		return $error;
	}
	global $wp_json_basic_auth_error;
	return $wp_json_basic_auth_error;
}
add_filter( 'rest_authentication_errors', 'json_basic_auth_error' );
// ********************************************************
function callDoliApi($method = null, $link = null, $body = null, $delay = HOUR_IN_SECONDS, $entity = null) {
global $wpdb;

$headers = array(
        'DOLAPIENTITY' => dolibarr_entity($entity),
        'DOLAPIKEY' => get_site_option('dolibarr_private_key')
    );

$url=get_site_option('dolibarr_public_url').'/api/index.php'.$link;

if ( !empty(get_site_option('dolibarr_public_url')) && !empty(get_site_option('dolibarr_private_key')) ) {
if ( !empty( $link ) && ( false ===  get_transient( $link ) || $method!='GET' || $delay <= 0 ) ) {

$args = array(
    'timeout' => '10',
    'redirection' => '5',
    'method' => $method,
    'headers' => $headers
); 

if ( $method == 'POST' ) {
$args['body'] = $body;
delete_transient( $link );  
$request = wp_remote_post( esc_url_raw($url), $args );
} elseif ( $method == 'PUT' ) {
$args['body'] = $body;
delete_transient( $link ); 
$request = wp_remote_request( esc_url_raw($url), $args );
} elseif ( $method == 'DELETE' ) { 
$request = wp_remote_request( esc_url_raw($url), $args );
} else {
$request = wp_remote_get( esc_url_raw($url), $args );
}

$http_code = wp_remote_retrieve_response_code( $request );

if ( $method == 'DELETE' ) {
delete_transient( $link ); 
} elseif ( $delay <= 0 || ! in_array( $http_code,array('200','404') ) ) {
delete_transient( $link );

if (! in_array($http_code,array('200', '400', '404')) ) {

if ( !defined("DOLIBUG") ) {
define('DOLIBUG', $http_code);
}

} elseif ( $delay != 0 ) {
$delay = abs( $delay );
set_transient( $link, wp_remote_retrieve_body( $request ), $delay);
}

} else {

set_transient( $link, wp_remote_retrieve_body( $request ), $delay );

}

return json_decode( wp_remote_retrieve_body( $request ) );

} else {
return json_decode( get_transient( $link ) );   
}
} else {

if ( !defined("DOLIBUG") ) {
define('DOLIBUG', 1);
}
}
}
add_action( 'admin_init', 'callDoliApi', 5, 5); 
// ********************************************************
function dolibarr() {
global $current_user;  

if ( is_user_logged_in() ) { 
$user=get_current_user_id(); 

$dolibarr = callDoliApi("GET", "/doliconnector/".$user, null, dolidelay('doliconnector', false));

if ( defined("DOLIBUG") || !is_object($dolibarr) ) {
define('DOLIBARR', null);
define('PRICE_LEVEL', 0);
define('REMISE_PERCENT', 0);
define('DOLIBARR_MEMBER', null);
define('DOLIBARR_TRAINEE', null);
define('DOLIBARR_USER', null);
define('DOLICONNECT_CART', 0);
define('DOLICONNECT_CART_ITEM', 0); 
} else {  
if ( empty($dolibarr->fk_soc) ) {

if ( $current_user->billing_type == 'mor' ) { 
if (!empty($current_user->billing_company)) { $name = $current_user->billing_company; }
else { $name = $current_user->user_login; }
} else {
if (!empty($current_user->user_firstname) && !empty($current_user->user_lastname)) { $name = $current_user->user_firstname." ".$current_user->user_lastname; }
else { $name = $current_user->user_login; }
} 

$rdr = [
    'name'  => $name,
    'email' => $current_user->user_email
	];
$dolibarr = callDoliApi("POST", "/doliconnector/".$user, $rdr, dolidelay('doliconnector'));
define('DOLIBARR', $dolibarr->fk_soc);
} else {   
define('DOLIBARR', $dolibarr->fk_soc);}
define('PRICE_LEVEL', $dolibarr->price_level);
define('REMISE_PERCENT', $dolibarr->remise_percent);
define('DOLIBARR_MEMBER', $dolibarr->fk_member);
define('DOLIBARR_TRAINEE', $dolibarr->fk_trainee);
define('DOLIBARR_USER', $dolibarr->fk_user); 
define('DOLICONNECT_CART', $dolibarr->fk_order);
define('DOLICONNECT_CART_ITEM', $dolibarr->fk_order_nb_item);
} 

} else {     
define('DOLIBARR', null);
define('PRICE_LEVEL', 0);
define('REMISE_PERCENT', 0);
define('DOLIBARR_MEMBER', null);
define('DOLIBARR_TRAINEE', null);
define('DOLIBARR_USER', null);
define('DOLICONNECT_CART', 0);
define('DOLICONNECT_CART_ITEM', 0);
} 

}
add_action( 'init', 'dolibarr', 10);
// ********************************************************
function doliconnector($current_user = null, $value = null, $refresh = false, $thirdparty = null) {

if ( empty($current_user) ) {
$current_user = wp_get_current_user();
}

if ( $current_user ) { 

$dolibarr = callDoliApi("GET", "/doliconnector/".$current_user->ID, null, dolidelay('doliconnector', $refresh));

if ( defined("DOLIBUG") || (is_object($dolibarr) && ! empty($dolibarr->fk_soc) ) )  {

if ( ! empty($value) ) {
return $dolibarr->$value;
} else {
return $dolibarr;
}
 
} else {

if ( isset($current_user->billing_type) && $current_user->billing_type == 'mor' ) { 
if (!empty($current_user->billing_company)) { $name = $current_user->billing_company; }
else { $name = $current_user->user_login; }
} else {
if ( ! empty($current_user->user_firstname) && ! empty($current_user->user_lastname) ) { $name = $current_user->user_firstname." ".$current_user->user_lastname; }
else { $name = $current_user->user_login; }
} 

$rdr = [
    'name'  => $name,
    'email' => $current_user->user_email
	];

$dolibarr = callDoliApi("POST", "/doliconnector/".$current_user->ID, $thirdparty, dolidelay('doliconnector', true));

if ( ! empty($value) ) {
return (isset($dolibarr->$value) ? $dolibarr->$value : null );
} else {
return $dolibarr;
}

}

}

}
// ********************************************************
add_filter( 'get_avatar' , 'my_custom_avatar' , 1 , 5 );

function my_custom_avatar( $avatar, $id_or_email, $size, $default, $alt ) {
global $wpdb;    
    $user = false;
if (get_site_option('doliconnect_mode')=='one' && is_multisite() ) {
switch_to_blog(1);
}      
    if ( is_numeric( $id_or_email ) ) {

        $id = (int) $id_or_email;
        $user = get_user_by( 'id' , $id );

    } elseif ( is_object( $id_or_email ) ) {

        if ( ! empty( $id_or_email->user_id ) ) {
            $id = (int) $id_or_email->user_id;
            $user = get_user_by( 'id' , $id );
        }

    } else {
        $user = get_user_by( 'email', $id_or_email );	
    }

    if ( $user && is_object( $user ) ) {

//if ( $user->data->ID == '1' ) {

$avatar = 'YOUR_NEW_IMAGE_URL';
//$avatar = "<img alt='{$alt}' src='{$avatar}' class='avatar avatar-{$size} photo' height='{$size}' width='{$size}' />";

if ($size=='96') {
$taille=" class='card-img-top' ";
} else {
$taille=" class='rounded-circle border border-white' height='{$size}' width='{$size}' ";   
}
$entity = get_current_blog_id();
$table_prefix = $wpdb->get_blog_prefix( $entity ); 
$nam=$table_prefix."member_photo";
if (isset($user->$nam) && NULL != $user->$nam) {
$upload_dir = wp_upload_dir(); 
$filename=$upload_dir['baseurl']."/doliconnect/".$user->data->ID."/".$user->$nam;
$avatar = "<img src='$filename' ".$taille." alt='avatar-".$user->data->ID."'>";
} else { 
$avatar = "<img src='" . plugins_url( 'images/default.jpg', __FILE__ ) . "' ".$taille."  alt='avatar-default'>";
}               
} else {
$taille=" class='card-img' ";
$avatar = "<img src='" . plugins_url( 'images/default.jpg', __FILE__ ) . "' ".$taille."  alt='avatar-default'>";
}
if ( get_site_option('doliconnect_mode')=='one' && is_multisite() ) {
restore_current_blog();
}
return $avatar;
}

// ********************************************************

function update_synctodolibarr($element) {
global $current_user,$wpdb;
$entity = get_current_blog_id();
wp_get_current_user();

if ($current_user->billing_type == 'phy'){
$name = $current_user->user_firstname." ".$current_user->user_lastname;}
else {$name = $current_user->billing_company;}
if (NULL != doliconnector($current_user, 'fk_member')) {
//$infomember = [
//   'login'  => $current_user->user_login,
//   'morphy'  => $current_user->billing_type,
//    'civility_id'  => $current_user->billing_civility,            
//    'firstname'  => $current_user->user_firstname,
//    'lastname'  => $current_user->user_lastname,
//    'address' => $current_user->billing_address,
//    'zip' => $current_user->billing_zipcode,
//    'town' => $current_user->billing_city,
//    'country_id' => $current_user->billing_country,
//    'email' => $current_user->user_email,
//    'phone' => $current_user->billing_phone,
//    'birth' => $current_user->billing_birth,
//    'array_options' => isset($extrafields) ? $extrafields : null
//	]; 
$adherent = callDoliApi("PUT", "/adherentsplus/".doliconnector($current_user, 'fk_member'), $element, 0);
//update_user_meta( $current_user->ID, 'billing_birth', $current_user->billing_birth);
}
if ( doliconnector($current_user, 'fk_soc') > 0 ) {
//$info = [
//    'status' => 1,
//    'name'  => $name,
//    'address' => $current_user->billing_address,
//    'zip' => $current_user->billing_zipcode,
//    'town' => $current_user->billing_city,
//    'country_id' => $current_user->billing_country,
//    'email' => $current_user->user_email,
//    'phone' => $current_user->billing_phone,
//    'url' => $current_user->user_url,
//    'array_options' => isset($extrafields) ? $extrafields : null
//	];
$thirparty = callDoliApi("PUT", "/thirdparties/".doliconnector($current_user, 'fk_soc'), $element, 0);
}

}
add_action('wp_dolibarr_sync','update_synctodolibarr', 1, 1);

// outils de personnalisation et utilisation du module
function my_login_logo_url() {
return get_bloginfo( 'url' );
}
add_filter( 'login_headerurl', 'my_login_logo_url' );

function my_login_logo_url_title() {
return 'nom du site';
}
add_filter( 'login_headertext', 'my_login_logo_url_title' );

// Hide Author EVERYWHERE
add_filter( 'generate_post_author','generate_modify_author_display' );
function generate_modify_author_display()
{
    //if ( is_single() )
    //    return true;
return false;
}

function my_register_page( $register_url ) {
return doliconnecturl('doliaccount') . '?signup';
}
add_filter( 'register_url', 'my_register_page' );

function my_lost_password_page( $lostpassword_url ) {
return doliconnecturl('doliaccount') . '?fpw';
}
if (get_option('doliaccount')) {
add_filter( 'lostpassword_url', 'my_lost_password_page', 10, 2 );}

function login_link_url( $url ) {
if (get_option('doliaccount')) {
return doliconnecturl('doliaccount'); }
}
if (get_option('doliaccount')) {
add_filter( 'login_url', 'login_link_url', 10, 2 ); }

add_filter('asgarosforum_filter_profile_link', 'my_profile_url', 10, 2);
function my_profile_url($profile_url, $user_object) {
return doliconnecturl('doliaccount');
}

function account_login_fail( $username ) {
$referrer = $_SERVER['HTTP_REFERER'];  
if ( !empty($referrer) && !strstr($referrer,'wp-login') && !strstr($referrer,'wp-admin') ) {
wp_redirect( esc_url( add_query_arg( 'login', 'failed', doliconnecturl('doliaccount')) ) );  // let's append some information (login=failed) to the URL for the theme to use
exit;}
}
add_action( 'wp_login_failed', 'account_login_fail' );  // hook failed login

function passresetmodif_login ($url, $redirect) { 
if (get_site_option('doliconnect_login')) {
$login_url=site_url()."/" . get_site_option('doliconnect_login');
}else {
$login_url=site_url()."/wp-login.php"; 
}
    $args = array( 'action' => 'lostpassword' );

    if ( !empty($redirect) )
        $args['redirect_to'] = $redirect;
    return add_query_arg( $args, $login_url );
}

?>
